<?php
/**
 * SPDX-FileCopyrightText: 2024 Sascha Nitsch (grumpydeveloper) https://contentnation.net/@grumpydevelop
 * SPDX-License-Identifier: GPL-3.0-or-later
 *
 * @author Yannis Vogel (vogeldevelopment)
 **/

namespace Federator\Data\ActivityPub\Common;

class Follow extends Activity
{
    /**
     * object overwrite
     * @var string
     */
    private $object = "";

    public function setFObject(string $object): void
    {
        $this->object = $object;
    }

    public function __construct()
    {
        parent::__construct("Follow");
        parent::addContext('https://www.w3.org/ns/activitystreams');
    }

    public function fromJson($json): bool
    {
        if (array_key_exists('object', $json)) {
            $this->object = $json['object'];
            unset($json['object']);
        }
        return parent::fromJson($json);
    }
    /**
     * convert internal state to php array
     * @return array<string,mixed>
     */
    public function toObject()
    {
        $return = parent::toObject();
        if ($this->object !== "") {
            $return['object'] = $this->object;
        }
        return $return;
    }
}
